// AudcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "demo3.h"
#include "AudcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAudcDlg dialog


CAudcDlg::CAudcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAudcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAudcDlg)
	m_bUseFile = FALSE;
	m_strFile = _T("l3codeca.acm");
	m_kbps = 0;
	//}}AFX_DATA_INIT
}


void CAudcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAudcDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Check(pDX, IDC_CHECK2, m_bUseFile);
	DDX_Text(pDX, IDC_EDIT1, m_strFile);
	DDX_Text(pDX, IDC_EDIT2, m_kbps);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAudcDlg, CDialog)
	//{{AFX_MSG_MAP(CAudcDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAudcDlg message handlers

void CAudcDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	CString codec;
	if ( m_bUseFile )
	{
		codec = m_strFile;
	}
	else
	{
		int sel = m_list.GetCurSel();
		if ( sel>=0 )
			m_list.GetText( sel, codec );
	}
	if ( codec.IsEmpty() )
	{
		MessageBox("please specify a audio codec", "server", MB_OK|MB_ICONWARNING);
		return;
	}
	
	COleVariant var(codec);
	COleVariant ret = m_pBox->call(0, "audio codec", var);
	if ( ret.lVal==0 )
	{
		MessageBox("cannot load the codec", "server", MB_OK|MB_ICONWARNING);
		return;
	}
	var.Clear();
	ret = m_pBox->call(ret.lVal, "test", var);
	bool ok = (ret.boolVal==VARIANT_TRUE);
	var.Clear();	
	m_pBox->call(ret.lVal, "close", var); //close the codec object
	if ( !ok )
	{
		MessageBox("open codec failed", "server", MB_OK|MB_ICONWARNING);
		return;
	}
	m_codec = codec;
	CDialog::OnOK();
}

bool CAudcDlg::Init(Cmmbox* p)
{
	m_pBox = p;
	//select default codec
	WCHAR* preference[] =
	{
		L"MPEG Layer-3 Codec ", //highest priority
		L"Microsoft GSM 6.10", 
		L"Microsoft G.723.1",
		L"TrueSpeech(TM)",
		L"Microsoft CCITT G.711", //lowest priority
		0
	};
	COleVariant var, ret;
	ret = p->call(0, "audc count", var);
	int c = ret.lVal;
	int sel = -1;
	for ( long i=0; i<c; ++i)
	{
		var = i;
		ret = p->call(0, "audc name", var);
		for ( int j=0; preference[j]!=0; ++j )
		{
			if ( !wcscmp(ret.bstrVal, preference[j]) )
			{
				if ( -1==sel || j<sel )
				{
					m_codec = ret.bstrVal;
					sel = j;
				}
			}
		}
	}
	if ( m_codec.IsEmpty() )
	{
		return (IDOK==DoModal());
	}
	return true;
}

BOOL CAudcDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_list.ResetContent();
	COleVariant var, ret;
	ret = m_pBox->call(0, "audc count", var);
	long c = ret.lVal;
	long sel = -1;
	for ( long i=0; i<c; ++i)
	{
		var = i;
		ret = m_pBox->call(0, "audc name", var);
		CString str(ret.bstrVal);
		m_list.AddString(str);
		if ( str==m_codec )
			sel = i;
	}
	if ( -1!=sel )
	{
		m_list.SetCurSel(sel);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
