// ClientSocket.cpp : implementation file
//

#include "stdafx.h"
#include "demo3.h"
#include "ClientSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientSocket
#include "clientDlg.h"

CClientSocket::CClientSocket()
{
	m_pDlg = 0;
	m_hwnd_connect = NULL;
	m_buf_size = 2000;
	m_buf = (char*)malloc(m_buf_size);
	m_buf_used = 0;
}

CClientSocket::~CClientSocket()
{
	if ( 0!=m_buf )
	{
		free(m_buf);
		m_buf = 0;
	}
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CClientSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CClientSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CClientSocket member functions
BOOL CClientSocket::Connect(HWND hWnd, LPCTSTR lpszHostAddress, UINT nHostPort)
{
	m_hwnd_connect = hWnd;

	return CAsyncSocket::Connect(lpszHostAddress, nHostPort);
}

void CClientSocket::OnConnect(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	::PostMessage(m_hwnd_connect, CLI_SOCK_CONNECT, (WPARAM)this, nErrorCode);

	CAsyncSocket::OnConnect(nErrorCode);
}

void CClientSocket::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class	
	CAsyncSocket::OnReceive(nErrorCode);
	if ( 0==m_pDlg )
		return;
	while ( true )
	{
		if ( -1==HandlePack() )
			break;

		int rb = this->Receive(m_buf+m_buf_used, m_buf_size-m_buf_used);
		if ( rb>0 )
		{
			m_buf_used +=rb;
			continue;
		}
		if ( SOCKET_ERROR==rb && WSAEWOULDBLOCK==GetLastError() )
		{
			return;
		}
		break; //socket closed
	}
	m_pDlg->OnSocketClose();
}

int CClientSocket::HandlePack()
{
	if ( m_buf_used<sizeof(Packet) )
		return 0;

	Packet* pkt = (Packet*)m_buf;
	if ( !pkt->verify(102400) ) // data length < 100K Bytes
		return -1;

	size_t pklen = pkt->size();
	if ( m_buf_used<pklen )
	{
		if ( m_buf_size<pklen )
		{
			m_buf_size = (pklen+1024)&(~1023);
			char* pBuf = (char*)malloc(m_buf_size);
			if ( 0==pBuf )
				return -1;
			memcpy(pBuf, m_buf, m_buf_used);
			free(m_buf);
			m_buf = pBuf;
		}
		return 0;
	}
	
	m_pDlg->OnSocketReceive(pkt);
	m_buf_used -= pklen;
	if ( m_buf_used!=0 )
	{
		memmove(m_buf, m_buf+pklen, m_buf_used);
	}
	return 1;
}

void CClientSocket::OnClose(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	CAsyncSocket::OnClose(nErrorCode);

	if ( 0!=m_pDlg )
		m_pDlg->OnSocketClose();
}

