// ServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "demo3.h"
#include "ServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerDlg dialog
#define FILE_LIST_MAX_SIZE 10000

CServerDlg::CServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bActive = false;
	m_listen = 0;
	ZeroMemory(m_tasks, sizeof(m_tasks));
	m_clients = 0;

	Packet* pkt = (Packet*)malloc(FILE_LIST_MAX_SIZE+500);
	pkt->init(PKT_FILE_LIST);
	m_files_pack = pkt;
}


void CServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerDlg)
	DDX_Control(pDX, IDC_LIST1, m_files);
	DDX_Control(pDX, IDC_11, m_mmb);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServerDlg, CDialog)
	//{{AFX_MSG_MAP(CServerDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_AUDC, OnAudc)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SAMPLE_PORT, OnAudcOutput)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerDlg message handlers

void CServerDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

BOOL CServerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_bActive = true;

	//open listen socket
	m_listen = new CListenSocket(this);
	BOOL ok = m_listen->Create(LISTEN_PORT, SOCK_STREAM, FD_ACCEPT) && m_listen->Listen();
	if ( !ok )
	{
		CString desc;
		desc.Format("Cannot listen on port %u", LISTEN_PORT);
		MessageBox(desc, "server", MB_OK|MB_ICONWARNING);
		PostMessage(WM_QUIT);
		return FALSE;
	}

	if ( !m_dlgAudc.Init(&m_mmb) )
	{
		PostMessage(WM_QUIT);
		return FALSE;
	}
	m_audc = m_dlgAudc.m_codec;

	OnStateChanged();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CServerDlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE);
	if ( IDOK==dlg.DoModal() )
	{
		CString path = dlg.GetPathName();
		TCHAR text[261];
		for ( int i=0; LB_ERR!=m_files.GetText(i, text); ++i )
		{
			if ( text==path ) //already exist
				return;
		}
		if ( m_files.AddString(path)>=0 )
		{
			OnFilesChanged();
		}
		return;
	}
}

void CServerDlg::OnRemove() 
{
	// TODO: Add your control notification handler code here
	int index = m_files.GetCurSel();
	if ( LB_ERR!=index && LB_ERR!=m_files.DeleteString(index) )
	{
		OnFilesChanged();
	}
}

void CServerDlg::OnSocketAccept(CAsyncSocket& so, SOCKADDR& addr)
{
	int i;
	for ( i=0; i<MAX_TASKS; ++i)
	{
		if ( 0==m_tasks[i] )
		{
			m_tasks[i] = new CServerTask(this, so, addr);
			++m_clients;
			OnStateChanged();
			break;
		}
	}
}

void CServerDlg::OnSocketClose(CServerTask* task)
{
	ASSERT (0!=task);
	for ( int i=0; i<MAX_TASKS; ++i )
	{
		if ( task==m_tasks[i] )
		{
			m_tasks[i] = 0;
			delete task;
			--m_clients;
			OnStateChanged();
			break;
		}
	}
}

void CServerDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	m_bActive = false;
	if ( 0!=m_listen )
	{
		delete m_listen;
		m_listen = 0;
	}
	for ( int i=0; i<MAX_TASKS; ++i)
	{
		CServerTask*& p = m_tasks[i];
		if ( 0!=p )
		{
			delete p;
			p = 0;
		}
	}
	if ( 0!=m_files_pack )
	{
		free(m_files_pack);
		m_files_pack = 0;
	}
}

void CServerDlg::OnStateChanged()
{
	CString str;
	str.Format("Clients: %u", m_clients);
	SetDlgItemText(IDC_STATIC_STATE, str);
}

void CServerDlg::OnFilesChanged()
{
	Packet* pkt = m_files_pack;
	if ( 0==pkt )
		return;
	pkt->init(PKT_FILE_LIST);
	PackString* str = (PackString*)pkt->data();
	void* end = ((char*)pkt) + FILE_LIST_MAX_SIZE;
	TCHAR text[261];
	for ( int i=0; true; ++i )
	{
		int cc = m_files.GetText(i, text);
		if ( cc<=0 )
			break;
		str->set(text, cc);
		str = (PackString*)str->end();
		if ( (void*)str>end )
			break;
	}
	pkt->data_len = (char*)str - pkt->data();
	for ( i=0; i<MAX_TASKS; ++i)
	{
		if ( 0!=m_tasks[i] )
		{
			m_tasks[i]->OnFilesChanged();
		}
	}
}
void CServerDlg::OnAudc() 
{
	// TODO: Add your control notification handler code here
	if ( IDOK==m_dlgAudc.DoModal() )
	{
		m_audc = m_dlgAudc.m_codec;
	}
}

LRESULT CServerDlg::OnAudcOutput(WPARAM wp, LPARAM lp)
{
	CServerTask* pTask = (CServerTask*)lp;
	if ( 0==pTask )
		return 0L;
	for ( int i=0; i<MAX_TASKS; ++i)
	{
		if ( pTask==m_tasks[i] )
		{
			pTask->OnAudcOutput((I_sample_port*)wp);
			break;
		}
	}
	return 0L;
}
